
	call	text
 
 box2 0,0,60,25,3
 hor2 0,15,60,3
 vert2 51,0,16,3
 hor  0,5,60,3
 hor  51,8,9,3
 hor  51,11,9,3
 hor  51,13,9,3
 
	bra	$

;;-------------------------------- BOX
;pbox:
;	sub	#0x101,w3	; -1=x, y-1=y
;	mov	#0x02,w0	; gornji levi ugao
;	call	corner
;	call	phor		; gornja linija
;
;	push	w1	; \000\
;	mov.b	6+1,WREG
;	add.b	2+1		; w1hi+w3hi=w1hi
;	mov	#0x05,w0	; donji levi ugao
;	call	corner
;	call	phor		; donja linija
;	add.b	w1,w3,w1
;	mov	#0x04,w0	; donji desni ugao
;	call	corner
;	pop	w1	; /
;
;	swap	w3
;	call	pvert		; leva linija
;	swap	w3
;	add.b	w1,w3,w1	; w1lo+w3lo=w1lo
;	swap	w3
;	mov	#0x03,w0	; gornji desni ugao
;	call	corner
;	call	pvert		; desna linija
;
;	return
;
;;-------------------------------- BOX2
;pbox2:
;	sub	#0x101,w3	; -1=x, y-1=y
;	mov	#0x12,w0	; gornji levi ugao
;	call	corner
;	call	phor2		; gornja linija
;
;	push	w1	; \000\
;	mov.b	6+1,WREG	; ...
;	add.b	2+1		; w1hi+w3hi=w1hi
;	mov	#0x15,w0	; donji levi ugao
;	call	corner
;	call	phor2		; donja linija
;	add.b	w1,w3,w1
;	mov	#0x14,w0	; donji desni ugao
;	call	corner
;	pop	w1	; /
;
;	swap	w3
;	call	pvert2		; leva linija
;	swap	w3
;	add.b	w1,w3,w1	; w1lo+w3lo=w1lo
;	swap	w3
;	mov	#0x13,w0	; gornji desni ugao
;	call	corner
;	call	pvert2		; desna linija
;
;	return
;
;corner:
;	swap	w4
;	push	w0	; \000\
;	mov	#120,w0
;	mul.b	2+1		; 2+1 = w1 hi byte
;	sl.b	2,WREG		; 8 = w1 lo byte
;	add	w2,w0,w2
;	mov	#BUFFER,w0
;	add	w2,w0,w2	; w2 = adr ugla kocke u video mem
;	pop	w0	; /
;	ior	w0,w4,[w2]
;	swap	w4
;	return
;
;;-------------------------------- HOR
;phor:
;	mov	#0x00,w5	; horizontal line
;	mov	#tbloffset(fit1h),w6
;	bra	skrhor
;
;;-------------------------------- HOR2
;phor2:
;	mov	#0x10,w5	; double horizontal line
;	mov	#tbloffset(fit2h),w6
;skrhor:
;	push	w1	; \000\
;	swap	w4
;	mov	#120,w0
;	mul.b	2+1		; 2+1 = w1 hi byte
;	sl.b	2,WREG		; 8 = w1 lo byte
;	add	w2,w0,w2
;	mov	#BUFFER,w0
;	add	w2,w0,w2	; w2 = adr pocetka linije u video mem
;
;	call	linefith	; first line char to write
;	add	#32,w6		; next fit table
;
;	clr	w0
;	sub.b	w3,#2,w0
;	bra	z,1f		; loop count = 0
;	bra	nc,1f		; loop count < 0
;	mov	w0,DOCOUNT
;2:				; \000\
;	call	linefith	; all line chars except 1st and last
;	dec	DOCOUNT
;	bra	nz,2b		; /
;1:
;	add	#32,w6		; next fit table
;	call	linefith	; last line char to write
;	swap	w4
;	pop	w1	; /
;	return
;
;linefith:
;	clr	w0
;	mov.b	[w2],w0		; postojeci znak u video mem
;	cp.b	w0,#31
;	btss	SR,#Z
;	bra	c,nofith	; no fit if there was not box char
;
;	add	w6,w0,w0
;	clr	w1
;	tblrdl.b [w0],w1	
;	ior	w4,w1,[w2++]	; write modified line
;	return
;nofith:
;	ior	w4,w5,[w2++]	; write unmodified line
;	return
;
;;-------------------------------- VERT
;pvert:
;	mov	#0x01,w5	; vertical line
;	mov	#tbloffset(fit1v),w6
;	bra	skrvert
;
;;-------------------------------- VERT2
;pvert2:
;	mov	#0x11,w5	; double vertical line
;	mov	#tbloffset(fit2v),w6
;skrvert:
;	push	w1	; \000\
;	swap	w4
;	mov	#120,w0
;	mul.b	2+1		; 2+1 = w1 hi byte
;	sl.b	2,WREG		; 8 = w1 lo byte
;	add	w2,w0,w2
;	mov	#BUFFER,w0
;	add	w2,w0,w2	; w2 = adr pocetka linije u video mem
;
;	call	linefith	; first line char to write
;	add	#118,w2		; readjust horizontal to vertical step
;	add	#32,w6		; next fit table
;
;	clr	w0
;	sub.b	w3,#2,w0
;	bra	z,1f		; loop count = 0
;	bra	nc,1f		; loop count < 0
;	mov	w0,DOCOUNT
;2:				; \000\
;	call	linefith	; all line chars except 1st and last
;	add	#118,w2		; readjust horizontal to vertical step
;
;	dec	DOCOUNT
;	bra	nz,2b		; /
;1:
;	add	#32,w6		; next fit table
;	call	linefith	; last line char to write
;	swap	w4
;	pop	w1	; /
;	return
;
;;linefitv:
;;	clr	w0
;;	mov.b	[w2],w0		; postojeci znak u video mem
;;	cp.b	w0,#31
;;	btss	SR,#Z
;;	bra	c,nofitv	; no fit if there was not box char
;;
;;	add	w6,w0,w0
;;	clr	w1
;;	tblrdl.b [w0],w1
;;
;;	mov	#tbloffset(color_allow),w0
;;	add	w0,w1,w0
;;	tblrdl.b [w0],w0
;;	cp0	w0
;;	bra	z,allow_colv
;;				; color attrib not allowed
;;	mov.b	w1,[w2++]	; write (color attrib is NOT modidfied here)
;;	inc	w2,w2
;;	return
;;allow_colv:			; color attrib allowed
;;	ior	w4,w1,[w2++]	; write (color attrib is modidfied here)
;;	return
;;nofitv:
;;	ior	w4,w5,[w2++]	; write unmodified line
;;	return
;
;
;;-------------------------------- TABLES
;fit1v:
;;	  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F
; .byte	0x09,0x01,0x02,0x03,0x06,0x07,0x06,0x07,0x0a,0x09,0x0a,0x0b,0x0c,0x0f,0x0e,0x0f
; .byte	0x0e,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x1e,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f
; .byte	0x0a,0x01,0x07,0x06,0x06,0x07,0x06,0x07,0x0a,0x0a,0x0a,0x0b,0x0c,0x0f,0x0f,0x0f
; .byte	0x0f,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x1e,0x1d,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f
; .byte	0x08,0x01,0x07,0x06,0x04,0x05,0x06,0x07,0x08,0x0a,0x0a,0x0b,0x0c,0x0d,0x0f,0x0f
; .byte	0x0d,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x1d,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f
;
;fit2v:
;;	  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F
; .byte	0x1f,0x11,0x0c,0x0b,0x0b,0x0c,0x0b,0x0c,0x1f,0x1f,0x1f,0x0b,0x0c,0x1a,0x1a,0x1a
; .byte	0x19,0x11,0x12,0x13,0x16,0x17,0x16,0x17,0x1a,0x19,0x1a,0x1b,0x1c,0x1d,0x1a,0x1f
; .byte	0x1f,0x11,0x0c,0x0b,0x0b,0x0c,0x0b,0x0c,0x1f,0x1f,0x1f,0x0b,0x0c,0x1a,0x1a,0x1a
; .byte	0x1a,0x11,0x17,0x16,0x16,0x17,0x16,0x17,0x1a,0x1a,0x1a,0x1b,0x1c,0x1a,0x1a,0x1f
; .byte	0x1f,0x11,0x0c,0x0b,0x0b,0x0c,0x0b,0x0c,0x1f,0x1f,0x1f,0x0b,0x0c,0x1a,0x1a,0x1a
; .byte	0x18,0x11,0x17,0x16,0x14,0x15,0x16,0x17,0x18,0x1a,0x1a,0x1b,0x1c,0x1a,0x1e,0x1f
;
;fit1h:
;;	  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F
; .byte	0x00,0x07,0x02,0x09,0x08,0x05,0x0a,0x07,0x08,0x09,0x0a,0x1f,0x0c,0x0d,0x0e,0x0f
; .byte	0x10,0x0c,0x12,0x13,0x14,0x15,0x1c,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f
; .byte	0x00,0x0a,0x09,0x09,0x08,0x08,0x0a,0x0a,0x08,0x09,0x0a,0x1f,0x1f,0x0d,0x0e,0x0f
; .byte	0x10,0x1f,0x12,0x13,0x14,0x15,0x1c,0x1b,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f
; .byte	0x00,0x06,0x09,0x03,0x04,0x08,0x06,0x0a,0x08,0x09,0x0a,0x0b,0x1f,0x0d,0x0e,0x0f
; .byte	0x10,0x0b,0x12,0x13,0x14,0x15,0x16,0x1b,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f
;
;fit2h:
;;	  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F
; .byte	0x10,0x0f,0x0e,0x0e,0x0d,0x0d,0x0f,0x0f,0x0d,0x0e,0x0f,0x1b,0x17,0x0d,0x0e,0x0f
; .byte	0x10,0x17,0x12,0x19,0x18,0x15,0x1a,0x17,0x18,0x19,0x1a,0x1b,0x1a,0x1d,0x1e,0x1b
; .byte	0x10,0x0f,0x0e,0x0e,0x0d,0x0d,0x0f,0x0f,0x0d,0x0e,0x0f,0x1a,0x1a,0x0d,0x0e,0x0f
; .byte	0x10,0x1a,0x19,0x19,0x18,0x18,0x1a,0x1a,0x18,0x19,0x1a,0x1a,0x1a,0x1d,0x1e,0x1a
; .byte	0x10,0x0f,0x0e,0x0e,0x0d,0x0d,0x0f,0x0f,0x0d,0x0e,0x0f,0x16,0x1c,0x0d,0x0e,0x0f
; .byte	0x10,0x16,0x19,0x13,0x14,0x18,0x16,0x1a,0x18,0x19,0x1a,0x1a,0x1c,0x1d,0x1e,0x1c
;
;;color_allow:
;; .byte	1,0,1,0,0,1,0,1,1,1,1,0,1,1,1,1, 1,0,1,0,0,1,0,1,1,1,1,1,1,1,1,1
;
;

text:
	mov	#tbloffset(string22),w1
	mov	#BUFFER,w2
	mov	#6,w3
3:
	tblrdl.b	[w1],w0

	cp.b	w0,#27
	bra	z,1f

	cp0.b	w0
	bra	nz,2f

	tblrdl.b	[++w1],w0
	mov	w0,w3
	swap	w3
	clr.b	w3
	inc	w1,w1
	bra	3b
2:
	clr	w0
	tblrdl.b	[w1++],w0
	ior	w0,w3,w0	; dodaje mu boju
	mov	w0,[w2++]
	bra	3b
1:
	return


;	red	\000\001
;	green	\000\002
;	blue	\000\004
;	cyan	\000\006
;	magenta	\000\005
;	yellow	\000\003
;	white	\000\007


string22:
 .ascii "                                                            "
 .ascii "\000\001 0\000\006 K[1]sa!                                         \000\001  ASCII  "
 .ascii "\000\001 1\000\006 K[1]G!                                          \000\001  ASCII  "
 .ascii "\000\001 2\000\006 Q[1]a1b1c0d1e1f1g1h0i0j0k1l1m0n0                \000\001  ASCII  "
 .ascii "\000\001 3\000\006 A5 22 70 F5 F5 00 20 18 79 11 01 01 01 01 27 00 \000\001  HEX    "
 .ascii "\000\001                                                            "
 	.byte	0,0x31,32,'0',0,0x31,32
 .ascii "01 01 01 A5 79 7A 71 01 01 01 0F F1 FE FE F6 BB\000\004   19200  "
 .ascii "\000\001 1\000\002 01 41 42 F5 67 9a 8F A5 5A 3C 77 71 77 07 00 00 \000\004  8-N-1  "
 .ascii "\000\001 2\000\002 46 20 BC C7 30 C4 0A 0A 01 01 79 28 91 90 44 B8          "
 	.byte	0,0x71,65,'3',32
 .ascii "F5 C1 CC CC 30 00 78 00 28 00 11 00 39 00 00 FF\000\003   L\000\005 000  "
 	.byte	0,0x01,32,'4',0,0x43,32
 .ascii "F1 E0 09 7E 7D B5 80 7F 7E 77 50 21 FF FF FF FF\000\003   R\000\005 004  "
 .ascii "\000\001 5\000\002 FF E3 7B 7A 7F 80 81 82 00 83 00 84 90 10 18 8A          "
 .ascii "\000\001 6\000\002 AB 45 5C ED 57 D8 39 11 18 B2 B0 A5 5A 3E F1 8A \000\006 \000\001 DOOR\000\0061  "
 .ascii "\000\001 7\000\002 51 7A BC DA DA 95 40 21 39 31 B7 B6 E5 E0 17 2A          "
 .ascii "\000\001 8\000\002 25 11 BD E1 E7 66 62 01 B7 0A 02 02 80 7F 25 11 \000\002 F1 HELP "
 .ascii "\000\001                                                            "
 .ascii "\000\001 0FA0 \000\00644\000\00330\000\00631\000\00331 \000\00673\000\00369\000\00666\000\00368 \000\006EF\000\00373\000\00669\000\00364 \000\00638\000\0034F\000\00644\000\00341 \000\007D011sifh.sid8ODA  "
 .ascii "\000\001 0FB0 \000\00642\000\00342\000\00626\000\00364 \000\00637\000\00337\000\00634\000\0036F \000\00631\000\00331\000\0066A\000\0034B \000\00639\000\00337\000\00672\000\00331 \000\007BB&d774o11jK97r1  "
 .ascii "\000\001 0FC0 \000\006F5\000\00340\000\006FF\000\003FA \000\00670\000\0036A\000\00664\000\0036B \000\00609\000\00347\000\0066A\000\00367 \000\00667\000\0036A\000\00647\000\00347 \000\007.@..pjdk.GjggjGG  "
 .ascii "\000\001 0FD0 \000\00657\000\00357\000\00658\000\00301 \000\006F0\000\003F0\000\006F0\000\003EF \000\006F1\000\003F2\000\00674\000\00374 \000\00623\000\00379\000\00611\000\00330 \000\007WWX.......tt3y.0  "
 .ascii "\000\001 0FE0 \000\0062A\000\0032B\000\00666\000\00366 \000\00635\000\00311\000\00635\000\00311 \000\00675\000\00349\000\00649\000\00370 \000\00623\000\0032C\000\0062C\000\0033D \000\007-+ff5.5.uIIp#,,=  "
 .ascii "\000\001 0FF0 \000\00625\000\00320\000\00653\000\00329 \000\00670\000\00370\000\0066A\000\00347 \000\00647\000\00377\000\0065E\000\0035F \000\00677\000\00357\000\0063D\000\00361 \000\007% S)ppjGGw^_wW=a  "
 .ascii "\000\001 1000 \000\00615\000\00352\000\00663\000\003FF \000\00600\000\003FF\000\00600\000\003FF \000\00675\000\00341\000\00630\000\00321 \000\00630\000\00371\000\00679\000\00301 \000\007.Rc.....uA0!0qy.  "
 .ascii "\000\001 1010 \000\00601\000\00312\000\00613\000\00314 \000\0064C\000\00347\000\00679\000\00369 \000\00675\000\00304\000\00604\000\00379 \000\00667\000\00370\000\00670\000\00370 \000\007....LGyiu..ygppp  "
 .word  27
here: